#include "linalg/type.hpp"
#include <catch2/catch.hpp>
#include <fit/crs.hpp>
#include <optmz/minmz.hpp>

using namespace Eigen;
TEST_CASE("less strike") {
  dynvec_t N(7);
  N << -0.1, -0.05, -0.022, 0.0, 0.022, 0.05, 0.1;
  dynvec_t x0(7);
  x0 << 15.0, 10.0, 10.0, 10.0, 10.0, 13.0, 14.0;
  constexpr size_t NUMX = 6;
  dynvec_t Fx(NUMX), Fy(NUMX), w(NUMX);
  Fx << -0.6, -0.3, -0.1, 0.022, 0.4, 0.7;
  Fy << 20.0, 17.0, 17.5, 15.0, 17.0, 18.3;
  w << 1.0, 1.0, 1.0, 2.0, 1.0, 0.5;

  cubic_spline_input_t inputs{};
  inputs.knots = N;
  inputs.x0 = x0;
  inputs.fitdata_x = Fx;
  inputs.fitdata_values = Fy;
  inputs.fitdata_weights = w;
  inputs.maxiter = 100;
  inputs.ftol = 1e-5;
  inputs.loss_scale = 1e5;
  cubic_spline_ws_t ws{};
  REQUIRE(!ws.success());
  ws.fit(inputs);
  printf("output [%s]\n", ws.modestr());
}
