def test_pyfit():
    import pyfit
    import numpy as np
    input = pyfit.MinmzRawInput()
    def cost(coef):
        return 10.0;
    def dcost(x):
        return x
    input.func = cost
    input.jac = dcost
    input.x0 = np.array([15.0, ] * 5)
    input.ftol = 1e-5
    input.bounds.lv = np.array([1.0]*5)
    input.bounds.uv = np.array([1.0]*5)
    assert input.num_cons() == 0
    def con_cost(coef):
        return np.array([10.0])
    def con_dcost(coef):
        return np.array([[10.0]])
    def con_cost2(coef):
        return np.array([1.0, 10.0])
    def con_dcost2(coef):
        return np.array([[10.0, 20.0]]).reshape(2,1)
    input.add_eq_con(con_cost2, con_dcost2, 2)
    input.add_ieq_con(con_cost, con_dcost, 1)
    input.add_ieq_con(con_cost2, con_dcost2, 2)
    assert input.sum_eq_cons_rows() == 2
    assert input.sum_ieq_cons_rows() == 3
    ws = pyfit.SLSQPWorkspace()
    ws.minimize(input)
    print(ws.modestr())
    print(ws.x())
    print(ws.g())
    print(ws.fx())

if __name__ == '__main__':
    test_pyfit()
